The Muddle programming languge is a member of the Lisp family. It 
started at MIT's Project MAC.

It's hard to pin down exactly when development began. The first 
documented reference to it seems to be in the Project MAC Progress 
Report VIII at <http://www.dtic.mil/docs/citations/AD0735148> which 
covered the period of July 1970 to July 1971 although some have 
claimed as early as 1969 but provide no sources.

The original MIT-DMS (along with other historically important systems 
like AI, MC, anmd ML) were KA- and KL-10 based PDP-10 systems running 
the Incompatible Timesharing System (ITS.) When they were retired in 
1982, four KS-10 systems ("DECSYSTEM-2020") were put in their place in 
order to keep ITS running. These were retired from service around 1995.

This mudman.git repository is named after the MUDMAN directory on 
MIT-DMS, which contained documentation about Muddle.

Many people have worked on Muddle in one aspect or other over the 
years. These include (in alphabetical order by first name): Brian 
Berkowitz, Bruce Daniels, Carl Hewitt, Chris Reeve, Dave Lebling, 
David Cressey, Gerald Sussman, Greg Pfister, Jim Michener, Joel Berez, 
Marc Blank, Michael Broos, Neal Ryan, Roger Banks, Stu Galley, Sue 
Pitkin, Tak To, Tim Anderson and others that will probably never be 
known.

This represents an effort to preseve information about the Muddle 
programming language by migrating the documentation from aging books 
into modern formats. Despite efforts to preserve the documentation as 
much as possible one change is made: Changing MDL references back to 
Muddle.

In talking to people that originally worked on the language it was 
always called Muddle.

The Muddle name was in the MIT AI Lab's tradition of naming Lisp 
dialects with somewhat sarcastic names. Reference other names from 
there like Planner, Scheme (which was actually named Schemer but ITS 
limited file names to a maximum of 6 characters), Conniver, etc. and 
it shows a pattern. Chris Reeve says that the Muddle name came from 
the nickname of the Project MAC Dynamic Modeling Group from either 
Gerald Sussman and/or Carl Hewitt, which was "Dynamic Muddlers."

The MDL name was actually invented by an administrator at the project 
that feared losing DARPA funding over a funny name. No one actually 
called it "MDL" except in documents DARPA might see and even then they 
wrote "MDL" but said "Muddle." The name "MIT Design Language" is, 
consequently, a backronym.

The Muddle name itself eventually got a backronym of "MAC's User 
Defined Data and Language Evaluator", with "MAC" representing "Project 
MAC".

Changing the MDL references back to Muddle is believed to be in 
support of the original naming decision of those that made the 
language, especially since there are no longer any DARPA funding 
concerns.

The documents in this repository, including this one, are made 
following the CommonMark specification: <http://commonmark.org/>.

Converting them to other formats requires that cmark, which is the 
reference implementation of Commonmark in C from 
<https://github.com/jgm/cmark> or Pandoc from <http://pandoc.org/> or 
some other program that can understand CommonMark be installed on your 
system.

---

This document by Jason Self is licensed under the Creative Commons 
Attribution-ShareAlike 4.0 International Public License and all future 
versions: <https://creativecommons.org/licenses/by-sa/4.0/>.
